=== debian/changelog ===
ovito (2.9.0+dfsg1-5ubuntu2) bionic; urgency=medium

  * Fix build failure with recent qscintilla. See: #885644.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 07 Feb 2018 10:52:52 +0100

ovito (2.9.0+dfsg1-5ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Avoid FTBFS by building with -O2 on ppc64el.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 23 Nov 2017 09:05:46 +0100

ovito (2.9.0+dfsg1-5) unstable; urgency=medium

  * [680282d] Relax some unreliable tests to make the build reproducible.

 -- Anton Gladky <gladk@debian.org>  Mon, 20 Nov 2017 22:46:48 +0100

ovito (2.9.0+dfsg1-4) unstable; urgency=medium

  * [cf29859] Do not fail on test, if data-file does not exist.

 -- Anton Gladky <gladk@debian.org>  Mon, 20 Nov 2017 18:58:20 +0100

ovito (2.9.0+dfsg1-3ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Avoid FTBFS by building with -O2 on ppc64el.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 Nov 2017 08:28:37 +0100

ovito (2.9.0+dfsg1-3) unstable; urgency=medium

  [ Anton Gladky ]
  * Team upload.
  * [0ce9a9a] Apply Standards-Version: 4.1.1
  * [6dabeb5] Remove myself from uploaders
  * [3e02bb4] Remove unneeded testsuite-field in d/control

  [ Gilles Filippini ]
  * [35bf4bd] Force using default Python 3 interpreter. (Closes: #878818)

 -- Anton Gladky <gladk@debian.org>  Sat, 18 Nov 2017 21:20:59 +0100

ovito (2.9.0+dfsg1-2ubuntu2) bionic; urgency=medium

  * Rebuild against new libnetcdf13.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 27 Oct 2017 13:34:38 +0200

ovito (2.9.0+dfsg1-2ubuntu1) artful; urgency=low

  * Merge from Debian Sid. Remaining changes:
    - Avoid FTBFS by building with -O2 on ppc64el.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Thu, 17 Aug 2017 00:02:03 -0500

ovito (2.9.0+dfsg1-2) unstable; urgency=medium

  * [cdb5bde] Fix FTBFS on archs, where char is unsigned. (Closes: #871248)

 -- Anton Gladky <gladk@debian.org>  Thu, 10 Aug 2017 19:44:59 +0200

ovito (2.9.0+dfsg1-1) unstable; urgency=medium

  * [7aa098e] Add missing dependency
  * [7aedcd1] Refresh patches, remove old ones.
  * [9629741] Disable avi-test.
  * [4cfa51d] Fix compilation with GCC 7. (Closes: #853603)
  * [527f425] Merge two patches.
  * [b48353b] New upstream version 2.9.0+dfsg1
  * [194099f] Bump Standards-Version: 4.0.0

 -- Anton Gladky <gladk@debian.org>  Sun, 06 Aug 2017 23:51:38 +0200

ovito (2.8.1+dfsg2-5ubuntu2) artful; urgency=medium

  * No-change rebuild against python3.6

 -- Jeremy Bicha <jbicha@ubuntu.com>  Fri, 28 Jul 2017 23:10:06 -0400

ovito (2.8.1+dfsg2-5ubuntu1) zesty; urgency=medium

  * Avoid FTBFS by building with -O2 on ppc64el

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Apr 2017 12:01:43 +0200
