=== debian/tests/control ===
Tests: ovitotest
Depends: ovito
