=== debian/watch ===
version=3
opts=repack,compression=xz,repacksuffix=+dfsg2,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//,\
filenamemangle=s/.*\.tar\.gz\?ref=v?(\d\S+)/ovito-$1\.tar\.gz/g \
https://gitlab.com/stuko/ovito/tags?sort=updated_desc .*archive\.tar\.gz\?ref=v?(\d\S+)
